(** Collection of areas *)
MODULE Areas;

IMPORT
  Area, Math:=mMath;

TYPE
  AreasArray = ARRAY 100 OF Area.Area;

  Float = Math.Float;

VAR
  areas:AreasArray;
  AreasCount: INTEGER;

PROCEDURE Add * (a:Area.Area);
  (** Adds the area to the collection. a=NIL is allowed. *)
  BEGIN
    ASSERT(AreasCount<LEN(areas));
    IF a#NIL THEN
      areas[AreasCount]:=a;
      INC(AreasCount);
    END;
  END Add;

PROCEDURE Index * (z,r:Float): INTEGER;
  (** Returns zero-based index of the area in the collection, which contains
      the specified point, or -1 if no area contains this point. *)
  VAR
    i:INTEGER;
  BEGIN
    ASSERT(AreasCount<LEN(areas));

    i:=AreasCount-1;
    WHILE (i>=0) & ~areas[i].Inside(z,r) DO
      DEC(i);
    END;
    RETURN i;
  END Index;

BEGIN
  AreasCount:=0;
END Areas.