MODULE Common;

IMPORT
  Math:=mMath, In:=msysTextIn, FileSys;

TYPE
  Float = Math.Float;

CONST
  PIFileName * = 'PI.txt';
  (** Name of file, where current or power of iteration is saved. *)

PROCEDURE LastIteration * (VAR val:Float): LONGINT;
  (* Analyses the last iteration, where the previous run of the program was stopped.
     Returns 0 if no previous iterations were found.
     In opposit case returns number of the iteration, where COMSOL error took place. *)
  VAR
    s:In.Scanner;
    i:LONGINT;
  BEGIN
    IF ~FileSys.Exists(PIFileName) THEN
      RETURN 0
    ELSE
      i:=0;
      In.OpenFile(s,PIFileName);
      In.SkipLine(s);
      In.SkipSpaces(s);
      WHILE ~In.EndOfInput(s) DO
        In.Float(s,val);
        In.SkipSpaces(s);
        INC(i);
      END;
      In.Close(s);
      RETURN i
    END;
  END LastIteration;

PROCEDURE FirstRun * (): BOOLEAN;
  (** Returns if this is a first run of the program *)
  BEGIN
    RETURN ~FileSys.Exists(PIFileName);
  END FirstRun;

END Common.